#include<iostream>
#include<vector>
using namespace std;
int N,O,A,B,AB;
vector <string> grupa;
vector <int> broj;
int matr[10001][5];
void unos()
{
    cin>>N>>O>>A>>B>>AB;
    for(int i=0; i<N; i++)
    {
        string a;
        int br;
        cin>>a;
        cin>>br;
        grupa.push_back(a);
        broj.push_back(br);
    }
}
void rez()
{
    memset(matr,0,sizeof matr);
    for(int i=0; i<N; i++)
    {
        if (grupa[i]=="O")
        {
            O-=broj[i];
            matr[i][0]=broj[i];
        }
    }
    for(int i=0; i<N; i++)
    {
        if (grupa[i]=="A")
        {
            if (A<broj[i])
            {
                matr[i][1]+=A;
                broj[i]-=A;
                A=0;
            }
            else
            {
                matr[i][1]+=broj[i];
                A-=broj[i];
                broj[i]=0;
            }
            matr[i][0]+=broj[i];
            O-=broj[i];
        }
    }
    for(int i=0; i<N; i++)
    {
        if (grupa[i]=="B")
        {
            if (B<broj[i])
            {
                matr[i][2]+=B;
                broj[i]-=B;
                B=0;
            }
            else
            {
                matr[i][2]+=broj[i];
                B-=broj[i];
                broj[i]=0;
            }
            matr[i][0]+=broj[i];
            O-=broj[i];
        }
    }
    for(int i=0; i<N; i++)
    {
        if (grupa[i]=="AB")
        {
            if (AB<broj[i])
            {
                matr[i][3]+=AB;
                broj[i]-=AB;
                AB=0;
            }
            else
            {
                matr[i][3]+=broj[i];
                AB-=broj[i];
                broj[i]=0;
            }
            if (A<broj[i])
            {
                matr[i][1]+=A;
                broj[i]-=A;
                A=0;
            }
            else
            {
                matr[i][1]+=broj[i];
                A-=broj[i];
                broj[i]=0;
            }
            if (B<broj[i])
            {
                matr[i][2]+=B;
                broj[i]-=B;
                B=0;
            }
            else
            {
                matr[i][2]+=broj[i];
                B-=broj[i];
                broj[i]=0;
            }
            matr[i][0]+=broj[i];
            O-=broj[i];
        }
    }
    if (O<0)
        cout<<"nemoguce"<<endl;
    else
    {
        cout<<"moguce"<<endl;
        for(int i=0; i<N; i++)
        {
            for(int j=0; j<4; j++)
                cout<<matr[i][j]<<' ';
            cout<<endl;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    unos();
    rez();
}